import sys
import traceback


class RedpeskUtilsError(Exception):
    pass


class ArchiveAlreadyThereError(RedpeskUtilsError):
    pass


class NoArchiveNameVersionError(RedpeskUtilsError):
    pass


class GitSourceError(RedpeskUtilsError):
    pass


class EmptySpecfileError(RedpeskUtilsError):
    pass

class SpecfileError(RedpeskUtilsError):
    pass


def formaterror():
    e, msg, tb = sys.exc_info()
    traceback.print_tb(tb)
    args = msg.args
    if isinstance(msg.args, tuple) or isinstance(msg.args, list):
        if len(msg.args) == 1:
            args = msg.args[0]

    return {
        "errors": args,
        "traceback": [t.translate(str.maketrans({"\n": " ", "\t": " "})) for t in traceback.format_tb(tb)],
        "type": str(e)
    }
