from contextlib import contextmanager
import ctypes
import io
import os, sys
import tempfile

def redirector(stream, std_str):
    std_fileno = getattr(sys.modules["sys"], f"__{std_str}__").fileno()
    with tempfile.TemporaryFile(mode='w+b') as f, os.fdopen(os.dup(std_fileno)) as bck:
        try:
            sysstd = getattr(sys.modules["sys"], std_str).flush()
            os.dup2(f.fileno(), std_fileno)
            yield
        finally:
            getattr(sys.modules["sys"], std_str).flush()
            os.dup2(bck.fileno(), std_fileno)
            f.flush()
            f.seek(0, io.SEEK_SET)
            stream.write(f.read())

@contextmanager
def redirect_stdout(stream):
    yield from redirector(stream, "stdout")

@contextmanager
def redirect_stderr(stream):
    yield from redirector(stream, "stderr")
