import asyncio
import platform
from pkg_resources import parse_version
import engineio
import time
import socketio

def schedule_ping(self):
    async def send_ping():
        self.last_ping = time.time()
        await asyncio.sleep(self.server.ping_interval)
        if not self.closing and not self.closed:
            self.last_ping = time.time()
            await self.send(engineio.packet.Packet(engineio.packet.PING))

    self.server.start_background_task(send_ping)

if parse_version(platform.python_version()) < parse_version('3.7'):
    asyncsocket36_send = engineio.asyncio_socket.AsyncSocket.send
    asyncsocket36_receive = engineio.asyncio_socket.AsyncSocket.receive
    async def receivefix(self, pkt):
        if pkt.packet_type == engineio.packet.PONG:
            schedule_ping(self)
        else:
            await asyncsocket36_receive(self, pkt)
    async def sendfix(self, pkt):
        if pkt.packet_type == engineio.packet.OPEN:
             schedule_ping(self)
        await asyncsocket36_send(self, pkt)
    engineio.asyncio_socket.AsyncSocket.receive = receivefix
    engineio.asyncio_socket.AsyncSocket.send = sendfix
