"""
*File:* setup.py
*Author:* Clément BENIER <clement.benier@iot.bzh>
*Date:* 29/01/2020

*Description:*
    Setup file needed for Python packaging

*License:*
    *Copyright (C) 2019 "IoT.bzh"*

    *Licensed under the Apache License, Version 2.0 (the "License");\
    you may not use this file except in compliance with the License.\
    You may obtain a copy of the License at:*

    *http://www.apache.org/licenses/LICENSE-2.0*

    *Unless required by applicable law or agreed to in writing, software\
    distributed under the License is distributed on an "AS IS" BASIS,\
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\
    implied.*
    *See the License for the specific language governing permissions and\
    limitations under the License.*
"""
from setuptools import setup
from redpesk_utils import common

version = common.VERSION if common.VERSION else "1.0"

setup(name='redpesk_utils',
      version=version,
      long_description='Redpesk utils',
      classifiers=[
          'Development Status :: 3 - Alpha',
          'License :: OSI Approved :: Apache Software License',
          'Programming Language :: Python :: 3.6',
          'Topic :: Internet :: WWW/HTTP :: WSGI :: Server',
      ],
      url='http://git.ovh.iot/redpesk/redpesk-utils.git',
      author='Clément Bénier',
      author_email='clement.benier@iot.bzh',
      license='Apache 2.0',
      packages=['redpesk_utils'],
      python_requires='>=3.6',
      install_requires=[
      ],
      zip_safe=False)

